Set Asymmetric Patterns.
From C4.Core Require Import
  Program.

Definition CounterState := nat.

Inductive CounterMethod: Type -> Type :=
| fetch: CounterMethod nat
| incAndFetch: CounterMethod nat.

Inductive CounterSem:
  forall {A}, CounterMethod A -> CounterState -> A -> CounterState -> Prop :=
| fetchSem v: 
    CounterSem fetch v v v
| incAndFetchSem: forall v,
    CounterSem incAndFetch v (S v) (S v).

Definition atomicCounter : Spec CounterMethod :=
  Build_Spec CounterMethod CounterState (@CounterSem) 0.

Lemma invertCounterSem R m s r s':
  @CounterSem R m s r s' ->
  
  match m in CounterMethod R' return R' -> Prop with
  | fetch =>
    fun r =>
      r = s
      /\ s = s'
              
  | incAndFetch =>
    fun r =>
      r = S s
      /\ s' = S s

  end r.

Proof.
  intros H1.
  destruct H1; auto.
Qed.
