From C4.Core Require Import
  Program
  Object.

Require Import C4.App.Register. (* "Register" is a keyword. *)
From C4.AppExtra Require Import
  Counter.

Module Type CounterImplParams.

  Parameter reg: Object (@RegisterMethod nat).

End CounterImplParams.


Module CounterImplFun (CounterImplArgs: CounterImplParams).
  Import CounterImplArgs.

  Definition base := reg.

  CoFixpoint readAndCasLoop :=
    v <- read;
    b <- cas v (S v);
    if b: bool then
      Return (S v)
    else
      readAndCasLoop.
    
  Definition impl Ret (m: CounterMethod Ret):
    Program (@RegisterMethod nat) Ret :=

    match m with
    | fetch =>
      r <- read;
      Return r

    | incAndFetch =>
      readAndCasLoop
      
    end.
  
  Definition counterImpl := flattenObject
                              base
                              CounterMethod
                              impl.

End CounterImplFun.



