Require Import
        Coq.Arith.Peano_dec        
        Coq.Structures.Equalities.

From C4.Core Require Import
  Program
  Object.
From C4.App Require Import
  Maps.
From C4.AppExtra Require Import
  Hist.
Import EMap.

Module Type HistImplParams (E : Typ).

  Parameter map: Object (EMapMethod E.t nat).

End HistImplParams.


Module HistImplFun (E : Typ) (HistImplArgs : HistImplParams E).

  Definition Key := E.t.
  Import HistImplArgs.

  Definition base := map.

  CoFixpoint incLoop (k: Key) :=
    vOpt <- EMap.get k;
    match vOpt with
    | Some v =>
      s <- EMap.replaceIt k v (v + 1);
      if s:bool then
        Return (v + 1)
      else
        incLoop k
      
    | None =>
      jOpt <- EMap.putIfAbsent k 1;
      match jOpt with      
      | Some j =>
        incLoop k
      | None =>
        Return 1
      end
    end.
      

  Definition impl R (m: HistMethod R):
    Program (EMapMethod Key nat) R :=
    match m with      
    | Hist.get k =>
      r <- EMap.get k;
      Return r
    | Hist.inc k =>
      incLoop k
    end.

  Definition histImpl :=
    flattenObject
      base
      HistMethod
      impl.

End HistImplFun.

