From C4.Core Require Import
  Program
  Simulates
  Threads.

Section MapBehavior.

  Context {Method Method' : Type -> Type}
          (f : forall Ret, Method' Ret -> Method Ret)
          (B : Spec (Interaction Method)).

  Fixpoint mapInteraction {Ret}
           (int : Interaction Method' Ret) :
    Interaction Method Ret :=
    match int with
    | Spawn m => Spawn (f _ m)
    | Join => Join
    | Up int' => Up (mapInteraction int')
    end.

  Definition MapBehavior : Spec (Interaction Method') := mapSpec B (@mapInteraction).

End MapBehavior.


Section MapBehaviorSimulates.

  Context {Method Method' : Type -> Type}
          (B1 : Spec (Interaction Method))
          (B2 : Spec (Interaction Method))
          (f : forall Ret, Method' Ret -> Method Ret).

  CoFixpoint mapBehaviorSimulates (st1 : B1.(State)) (st2 : B2.(State)) :
    Simulates_ B1 B2 st1 st2 ->
    Simulates_ (MapBehavior f B1) (MapBehavior f B2) st1 st2.
  Proof.
    intros [S].
    split.
    simpl.
    intros.
    edestruct S; eauto.
  Qed.

End MapBehaviorSimulates.
