From C4.Core Require Import
  Program.

Definition PairMethod MethodL MethodR (Ret : Type) := sum (MethodL Ret) (MethodR Ret).

Section Pair.

  Context {InstructionL InstructionR}
          (specL : Spec InstructionL)
          (specR : Spec InstructionR).

  Definition PairInstruction (Ret : Type) := sum (InstructionL Ret) (InstructionR Ret).

  Definition EvalPairInstruction A instr st (a : A) st' :=
    match instr with
      | inl instr' => specL.(EvalInstruction) instr' (fst st) a (fst st') /\ (snd st = snd st')
      | inr instr' => specR.(EvalInstruction) instr' (snd st) a (snd st') /\ (fst st = fst st')
    end.

  Definition pairSpec : Spec PairInstruction :=
    {|
      State := prod specL.(State) specR.(State);
      EvalInstruction := EvalPairInstruction;
      initialState := (specL.(initialState), specR.(initialState))
    |}.

End Pair.

Arguments PairInstruction : clear implicits.

