From C4.Core Require Import
  Program.

Definition ProdMethod {T} Method (Ret : Type) := {t : T & Method t Ret}.

Section Prod.

  Context
    {T Instruction}
    (spec : forall t : T, Spec (Instruction t)).

  Definition EvalProdInstruction A (instr : ProdMethod Instruction A) st a st' :=
     let (t, instr') := instr in
     EvalInstruction (spec t) instr' (st t) a (st' t) /\
     (forall t' : T, t <> t' -> st t' = st' t').

  Definition prodSpec : Spec (ProdMethod Instruction) :=
    {|
      State := forall t, (spec t).(State);
      EvalInstruction := EvalProdInstruction;
      initialState := fun t => (spec t).(initialState)
    |}.

End Prod.
