Require Import
        Coq.Lists.List
        Coq.Relations.Relations
        Coq.Sets.Ensembles.

From C4.Core Require Import
  Program
  Object.

Section Simulates.

  Context {Interaction: Type -> Type}
          (spec1 : Spec Interaction) (* concrete *)
          (spec2 : Spec Interaction) (* abstract *).

  CoInductive Simulates_ (s1 : spec1.(State)) (s2 : spec2.(State)) : Prop :=
  | SimStep :
      (forall R int (r : R) s1',
         spec1.(EvalInstruction) int s1 r s1' ->
         exists2 s2',
           spec2.(EvalInstruction) int s2 r s2' &
           Simulates_ s1' s2') ->
      Simulates_ s1 s2.

  Definition Simulates : Prop := Simulates_ spec1.(initialState) spec2.(initialState).

End Simulates.
