From Coq Require Import
  List
  Arith
  Setoid
  Morphisms
  FunctionalExtensionality.

From C4.Util Require LibTactics.

Ltac injpair := LibTactics.injpair.

From C4.Util Require Import Util.
From C4.Core Require Import
  Program
  ProgramOps
  Object
  Pair
  Threads
  Superposition
  Simulates
  BaseSimulates
  HConcSimulates
  Trace
  Trace_Basics
  Trace_ConcSimulates
  Linearizability.

Lemma Lin_ConcTraceIncl {M} (obj : Object M) spec
  : Linearizable spec obj -> ConcTraceIncl obj (serialObject spec).
Proof.
  intros H. apply ConcSimulates_ConcTraceIncl, HConcSimulatesConcSimulates, H.
Qed.
