From C4.Core Require Import
  Program
  Simulates.


Section BSimulates.  

  Context {M: Type -> Type}
          (obj1 : Spec M) (* concrete *)
          (obj2 : Spec M) (* abstract *).

  Definition leftTotal {D1 D2} (r: D1 -> D2 -> Prop) :=
    forall s1, exists s2, r s1 s2.

  (* Init condition:
     for all s in start C, image of s is a subset of start of A.  *)
  Definition BSimulates
             (rel: obj1.(State) -> obj2.(State) -> Prop)
             (si1: obj1.(State)) (si2 : obj2.(State)) : Prop :=
    leftTotal rel
    /\ (forall s2,
          rel si1 s2 ->
          s2 = si2)
    /\ (forall R s1 int (r : R) s1' s2',
          rel s1' s2' ->
          obj1.(EvalInstruction) int s1 r s1' ->
          exists s2, obj2.(EvalInstruction) int s2 r s2'
                /\ rel s1 s2).
End BSimulates.
