From Coq Require Import Arith NArith.
From C4.Util Require Import LibTactics.


Import Nat.

Lemma DivDivModEq:
  forall a b d1 d2,
    d1 <> 0 ->
    d2 <> 0 ->
    d2 mod d1 = 0 ->
    a mod d2 = b mod d2 ->
    a mod d1 = b mod d1.

Proof.
  introv H1 H2 H3 H4.
  apply mod_divides in H3.
  Focus 2. assumption.
  destruct H3 as (c & H3).
  subst.

  assert (H5 := H4).
  assert (H6 := H4).
  rewrite PeanoNat.Nat.mod_eq in H4.
  Focus 2. assumption.
  symmetry in H5.
  rewrite PeanoNat.Nat.mod_eq in H5.
  Focus 2. assumption.
  remember (b mod (d1 * c)) as m.
  destruct (eq_nat_dec m 0).
  - subst.
    rewrite e in H6.
    rewrite mod_divides in H6.
    Focus 2. assumption.
    destruct H6 as (k1 & H6).
    rewrite <- mul_assoc in H6.
    rewrite mod_divides in e.
    Focus 2. assumption.
    destruct e as (k2 & H7).
    rewrite <- mul_assoc in H7.
    forwards A1: mod_divides H1. destruct A1 as (_ & A1).
    forwards A1': A1. eexists. exact H6. clear A1.
    forwards A2: mod_divides H1. destruct A2 as (_ & A2).
    forwards A2': A2. eexists. exact H7. clear A2.
    congruence.

  - rewrite H6 in *. clear Heqm H6.    
    remember (a / (d1 * c)) as k1.
    remember (b / (d1 * c)) as k2.
    clear Heqk1 Heqk2.
    eapply add_sub_eq_nz in H4.
    Focus 2. assumption.
    rewrite add_comm in H4.
    rewrite mul_comm in H4.
    rewrite (mul_comm d1 c) in H4.
    rewrite mul_assoc in H4.

    eapply add_sub_eq_nz in H5.
    Focus 2. assumption.
    rewrite add_comm in H5.
    rewrite mul_comm in H5.
    rewrite (mul_comm d1 c) in H5.
    rewrite mul_assoc in H5.

    subst.

    rewrite mod_add.
    Focus 2. assumption.
    rewrite mod_add.
    Focus 2. assumption.
    reflexivity.

Qed.

    
Lemma noOverflow:
  forall (s : {n : nat | 0 < n}) h,
    proj1_sig s <= h mod proj1_sig s -> False.
Proof.
  introv H1.
  apply Lt.le_not_lt in H1.
  apply H1. apply mod_upper_bound.
  destruct s. simpl in *.
  eapply not_eq_sym. eapply lt_neq. assumption.
Qed.                

Lemma noOverflow':
  forall (s : {n : nat | 0 < n}) h,
    h mod proj1_sig s < proj1_sig s.
Proof.
  intros.
  apply mod_upper_bound.
  destruct s. simpl in *.
  eapply not_eq_sym. eapply lt_neq. assumption.
Qed.
